#include <avr/io.h>
//#include <config.h>
#include <stdlib.h>

#ifndef ANZ_MES
#define ANZ_MES 44
#endif

.GLOBAL ReadADC
.GLOBAL W20msReadADC
.GLOBAL W5msReadADC
//.GLOBAL minmul
//.GLOBAL mindiv

;unsigned int W20msReadADC(uint8_t mux) {
W20msReadADC:
  rcall	wait20ms;
  rjmp	ReadADC


;unsigned int W5msReadADC(uint8_t mux) {
W5msReadADC:
  rcall	wait5ms
// laeuft weiter in ReadADC

;unsigned int ReadADC(uint8_t mux) {
ReadADC:
  //ADC-Wert des angegebenen Kanals auslesen und als unsigned int zurckgeben
;  unsigned int adcx;
;  uint8_t jj;

;  ADMUX = mux | (1<<REFS0);
  mov   r22,r24
  ori	r24, 1<<REFS0
#if ADMUX < 32
  out   ADMUX, r24
#else
  sts	ADMUX, r24
#endif
;  adcx = (ANZ_MES/11); 	// runden des Ergebnis (+4)
;  ADCSRA |= (1<<ADSC);		//starte Conversion
#if ADCSRA < 32
  sbi	ADCSRA,ADSC
#else
  lds	r18, ADCSRA
  ori	r18, (1<<ADSC)
  sts	ADCSRA, r18
#endif

//  while (ADCSRA&(1<<ADSC));		//warte
w3f6:
#if ADCSRA < 32
  sbi	ADCSRA,ADSC
#else
  lds	r18, ADCSRA
  sbrc	r18, ADSC
#endif
  rjmp	w3f6 

;  wait300us();
  rcall	wait300us

;  adcx = (ANZ_MES/11); 	// runden des Ergebnis (+4)
  ldi	r24, (ANZ_MES/11)
  ldi	r25, 0

;  for (jj = 0; jj < ANZ_MES; jj++) {
     //ANZ_MESS Messungen; fr bessere Genauigkeit
  ldi	r20, 0

forlop1:
;     ADCSRA |= (1<<ADSC);		//starte Conversion
#if ADCSRA < 32
  sbi	ADCSRA,ADSC
#else
  lds	r18, ADCSRA
  ori	r18, (1<<ADSC)
  sts	ADCSRA, r18
#endif

;     while (ADCSRA & (1<<ADSC));		//warte
w416:
#if ADCSRA < 32
  sbic	ADCSRA,ADSC
#else
  lds	r18, ADCSRA
  sbrc	r18, ADSC
#endif
  rjmp	w416 

;     adcx += ADCW;		//  Messung addieren
#if ADCH < 32
  in	r18,ADCL
  in	r19,ADCH
#else
  lds	r18, ADCL
  lds	r19, ADCH
#endif
  add	r24, r18
  adc	r25, r19

#ifdef AUTOSCALE_ADC
;     if ((jj == 4) && (adcx < 1024)){
  cpi	r20, 0x04	; 4
  brne	r436 
  ldi	r21, 0x04	; 4
  cpi	r24, 0
  cpc	r25, r21
  brcs	r444 
#endif

;  for (jj = 0; jj < ANZ_MES; jj++) {
r436:
  subi	r20, 0xFF	; 255
  cpi	r20, ANZ_MES
  brne	forlop1 

#if ANZ_MES == 22
;  adcx *= 2;
  add	r24,r24
  adc	r25,r25		;*2
#endif
  
#if ANZ_MES == 11
;  adcx *= 4;
  add	r24,r24
  adc	r25,r25		;*2
  add	r24,r24
  adc	r25,r25		;*2
#endif

;  return adcx/9;
  ldi	r22, 0x09	; 9
  ldi	r23, 0

#ifdef AUTOSCALE_ADC
  rjmp	diviret 
  
r444:
;  adcx = 0;
;  ADMUX = mux | (1<<REFS1) | (1<<REFS0); // Internal 1.1V Referenz
  ori	r22, (1<<REFS1)|(1<<REFS0)
#if ADMUX < 32
  out	ADMUX, r22
#else
  sts	ADMUX, r22
#endif

;  ADCSRA |= (1<<ADSC);		//starte Conversion
#if ADCSRA < 32
  sbi	ADCSRA,ADSC
#else
  lds	r24, ADCSRA
  ori	r24, (1<<ADSC)
  sts	ADCSRA, r24
#endif

;  while (ADCSRA&(1<<ADSC));		//warte
w454:
#if ADCSRA < 32
  sbic	ADCSRA, ADSC
#else
  lds	r24, ADCSRA
  sbrc	r24, ADSC
#endif
  rjmp	w454 

;  wait5ms();
;  wait1ms();
  rcall	wait5ms
  rcall	wait1ms

;  adcx = 0;
  ldi	r24, 0x00	; 0
  ldi	r25, 0x00	; 0

;  for (jj=0; jj<minmul; jj++) {
  ldi	r20, 0x00	; 0
  rjmp	r48c

;     ADCSRA |= (1<<ADSC);		//starte Conversion
forlop2:
#if ADCSRA < 32
  sbi	ADCSRA, ADSC
#else
  lds	r18, ADCSRA
  ori	r18, (1<<ADSC)
  sts	ADCSRA, r18
#endif

;     while (ADCSRA&(1<<ADSC));		//warte
w476:
#if ADCSRA < 32
  sbic	ADCSRA, ADSC
#else
  lds	r18, ADCSRA
  sbrc	r18, ADSC
#endif
  rjmp	w476 

;     adcx += ADCW;			//Messungen zusammenzhlen
#if ADCSRA < 32
  in	r18, ADCL
  in	r19, ADCH
#else
  lds	r18, ADCL
  lds	r19, ADCH
#endif
  add	r24, r18
  adc	r25, r19

;  for (jj=0; jj<minmul; jj++) {
  subi	r20, 0xFF	; 255
r48c:
  lds	r18, minmul
  cp	r20, r18
  brcs	forlop2 

;  return (adcx/mindiv);			//Auflsung mV
  lds	r22, mindiv
  ldi	r23, 0
#endif
diviret:
  rcall	__udivmodhi4
  movw	r24, r22
  clr	r0
  ret

